package net.sergeych.cloudoc.api

import kotlinx.serialization.Serializable

@Serializable
sealed class Package {

    @Serializable
    data class Command(val id: Int, val name: String, val args: ByteArray) : Package()

    @Serializable
    data class Response(
        val toId: Int,
        val result: ByteArray? = null,
        val errorCode: String? = null,
        val errorText: String? = null,
    ) : Package() {
        init {
            if (result == null && errorCode == null)
                throw IllegalArgumentException("either result or errorCode must not be null")
        }
    }

//    @Serializable
//    data class Push(val payload: PushPayload) : Package()
}


